net.sf.saxon.expr

## Class XPathContextMajor

- java.lang.Object
- - net.sf.saxon.expr.XPathContextMinor
  - - net.sf.saxon.expr.XPathContextMajor

- All Implemented Interfaces:
    XPathContext

      public class XPathContextMajor
      extends XPathContextMinor

  This class represents a "major context" in which an XPath expression is evaluated: a "major context" object allows all aspects of the dynamic context to change, whereas a "minor context" only allows changes to the focus and the destination for push output.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `XPathContextMajor.ThreadManager`

    - ### Nested classes/interfaces inherited from class net.sf.saxon.expr.XPathContextMinor

      `XPathContextMinor.LastValue`

  - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.XPathContextMinor

      `stackFrame`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XPathContextMajor(Controller controller)` Constructor should only be called by the Controller, which acts as a XPathContext factory.
    `XPathContextMajor(Item item, Configuration config)` Deprecated. since 9.0 - use `XPathContextMajor(Item, Executable)`
    `XPathContextMajor(Item item, Executable exec)` Constructor for use in free-standing Java applications.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addChildThread(Thread t)` Add a new thread to the list of child threads for this context.
    `void` | `createThreadManager()`
    `Sequence[]` | `getAllVariableValues()` Get a all the variables in the stack frame
    `GroupIterator` | `getCurrentGroupIterator()` Get the current group iterator.
    `Mode` | `getCurrentMode()` Get the current mode.
    `RegexIterator` | `getCurrentRegexIterator()` Get the current regex iterator.
    `Rule` | `getCurrentTemplateRule()` Get the current template.
    `ParameterSet` | `getLocalParameters()` Get the local parameters for the current template call.
    `InstructionInfo` | `getOrigin()` Get information about the creating expression or other construct.
    `int` | `getOriginatingConstructType()` Get the type of location from which this context was created.
    `UserFunction` | `getTailCallFunction()` Determine whether the body of a function is to be repeated, due to tail-recursive function calls
    `XPathContextMajor.ThreadManager` | `getThreadManager()`
    `ParameterSet` | `getTunnelParameters()` Get the tunnel parameters for the current template call.
    `boolean` | `isTemporaryOutputState()` Ask whether the XSLT output state is "temporary" or "final"
    `XPathContextMajor` | `newContext()` Construct a new context as a copy of another.
    `static XPathContextMajor` | `newContext(XPathContextMinor prev)` Create a new "major" context (one that is capable of holding a stack frame with local variables
    `static XPathContextMajor` | `newThreadContext(XPathContextMinor prev)` Make a copy of the supplied context for use in a new thread (typically for an asynchronous xsl:result-document
    `void` | `notifyChildThreads()` Check for running child threads and wait for them to complete and join to main thread.
    `void` | `openStackFrame(int numberOfVariables)` Create a new stack frame large enough to hold a given number of local variables, for which no stack frame map is available.
    `void` | `openStackFrame(SlotManager map)` Create a new stack frame for local variables, using the supplied SlotManager to define the allocation of slots to individual variables
    `void` | `requestTailCall(UserFunction fn, Sequence[] variables)` Reset the local stack frame.
    `void` | `resetAllVariableValues(Sequence[] values)` Overwrite all the variables in the stack frame
    `void` | `resetParameterValues(Sequence[] values)` Overwrite all the parameters in the stack frame.
    `void` | `resetStackFrameMap(SlotManager map, int numberOfParams)` Reset the stack frame variable map, while reusing the StackFrame object itself.
    `void` | `setCurrentGroupIterator(GroupIterator iterator)` Set the current grouping iterator.
    `void` | `setCurrentMode(Mode mode)` Set the current mode.
    `void` | `setCurrentRegexIterator(RegexIterator currentRegexIterator)` Set the current regex iterator.
    `void` | `setCurrentTemplateRule(Rule rule)` Set the current template.
    `void` | `setLocalParameters(ParameterSet localParameters)` Set the local parameters for the current template call.
    `void` | `setOrigin(InstructionInfo expr)` Set the creating expression (for use in diagnostics).
    `void` | `setOriginatingConstructType(int loc)` Set the type of creating expression (for use in diagnostics).
    `void` | `setStackFrame(SlotManager map, Sequence[] variables)` Set the local stack frame.
    `void` | `setTemporaryOutputState(boolean temporary)` Set the XSLT output state to "temporary" or "final"
    `void` | `setTunnelParameters(ParameterSet tunnelParameters)` Set the tunnel parameters for the current template call.
    `int` | `useLocalParameter(int parameterId, int slotNumber, boolean isTunnel)` Use local parameter.

    - ### Methods inherited from class net.sf.saxon.expr.XPathContextMinor

      `changeOutputDestination, evaluateLocalVariable, getCaller, getCollation, getConfiguration, getContextItem, getController, getCurrentDateTime, getCurrentException, getCurrentIterator, getImplicitTimezone, getLast, getNameChecker, getNamePool, getReceiver, getStackFrame, isAtLast, iterateStackFrames, newCleanContext, newMinorContext, setCaller, setCurrentException, setCurrentIterator, setLocalVariable, setReceiver`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### XPathContextMajor

          public XPathContextMajor(Controller controller)

      Constructor should only be called by the Controller, which acts as a XPathContext factory.
      Parameters:
        `controller` - the Controller

    - #### XPathContextMajor

          public XPathContextMajor(Item item,
                           Executable exec)

      Constructor for use in free-standing Java applications.
      Parameters:
        `item` - the item to use as the initial context item. If this is null, the comtext item is initially undefined (which will cause a dynamic error if it is referenced).
        `exec` - the Executable

    - #### XPathContextMajor

          public XPathContextMajor(Item item,
                           Configuration config)

      Deprecated. since 9.0 - use `XPathContextMajor(Item, Executable)`
      Constructor for use in free-standing Java applications.
      Parameters:
        `item` - the item to use as the initial context item. If this is null, the comtext item is initially undefined (which will cause a dynamic error if it is referenced).
        `config` - the Saxon Configuration

  - ### Method Detail

    - #### addChildThread

          public void addChildThread(Thread t)

      Add a new thread to the list of child threads for this context. Create threadManager if null.
      Parameters:
        `t` - the Thread

    - #### getThreadManager

          public XPathContextMajor.ThreadManager getThreadManager()

    - #### createThreadManager

          public void createThreadManager()

    - #### notifyChildThreads

          public void notifyChildThreads()
                                  throws XPathException

      Check for running child threads and wait for them to complete and join to main thread. Throw any exception caught in any of the running threads
      Specified by:
        `notifyChildThreads` in interface `XPathContext`
      Overrides:
        `notifyChildThreads` in class `XPathContextMinor`
      Throws:
        `XPathException`

    - #### newContext

          public XPathContextMajor newContext()

      Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context. The
      Specified by:
        `newContext` in interface `XPathContext`
      Overrides:
        `newContext` in class `XPathContextMinor`
      Returns:
        a new context, created as a copy of this context

    - #### newContext

          public static XPathContextMajor newContext(XPathContextMinor prev)

      Create a new "major" context (one that is capable of holding a stack frame with local variables
      Parameters:
        `prev` - the previous context (the one causing the new context to be created)
      Returns:
        the new major context

    - #### newThreadContext

          public static XPathContextMajor newThreadContext(XPathContextMinor prev)

      Make a copy of the supplied context for use in a new thread (typically for an asynchronous xsl:result-document
      Parameters:
        `prev` - the context to be copied
      Returns:
        the copy of the context

    - #### getLocalParameters

          public ParameterSet getLocalParameters()

      Get the local parameters for the current template call.
      Specified by:
        `getLocalParameters` in interface `XPathContext`
      Overrides:
        `getLocalParameters` in class `XPathContextMinor`
      Returns:
        the supplied parameters

    - #### setLocalParameters

          public void setLocalParameters(ParameterSet localParameters)

      Set the local parameters for the current template call.
      Parameters:
        `localParameters` - the supplied parameters

    - #### getTunnelParameters

          public ParameterSet getTunnelParameters()

      Get the tunnel parameters for the current template call.
      Specified by:
        `getTunnelParameters` in interface `XPathContext`
      Overrides:
        `getTunnelParameters` in class `XPathContextMinor`
      Returns:
        the supplied tunnel parameters

    - #### setTunnelParameters

          public void setTunnelParameters(ParameterSet tunnelParameters)

      Set the tunnel parameters for the current template call.
      Parameters:
        `tunnelParameters` - the supplied tunnel parameters

    - #### setOrigin

          public void setOrigin(InstructionInfo expr)

      Set the creating expression (for use in diagnostics). The origin is generally set to "this" by the object that creates the new context. It's up to the debugger to determine whether this information is useful. The object will either be an `Expression`, allowing information about the calling instruction to be obtained, or null.

    - #### setOriginatingConstructType

          public void setOriginatingConstructType(int loc)

      Set the type of creating expression (for use in diagnostics). When a new context is created, either this method or `setOrigin(net.sf.saxon.trace.InstructionInfo)` should be called.
      Parameters:
        `loc` - The originating location: the argument must be one of the integer constants in class `Location`

    - #### getOriginatingConstructType

          public int getOriginatingConstructType()

      Get the type of location from which this context was created.

    - #### getOrigin

          public InstructionInfo getOrigin()

      Get information about the creating expression or other construct.

    - #### setStackFrame

          public void setStackFrame(SlotManager map,
                           Sequence[] variables)

      Set the local stack frame. This method is used when creating a Closure to support delayed evaluation of expressions. The "stack frame" is actually on the Java heap, which means it can survive function returns and the like.
      Parameters:
        `map` - the SlotManager, which holds static details of the allocation of variables to slots
        `variables` - the array of "slots" to hold the actual variable values. This array will be copied if it is too small to hold all the variables defined in the SlotManager

    - #### resetStackFrameMap

          public void resetStackFrameMap(SlotManager map,
                                int numberOfParams)

      Reset the stack frame variable map, while reusing the StackFrame object itself. This is done on a tail call to a different function
      Parameters:
        `map` - the SlotManager representing the stack frame contents
        `numberOfParams` - the number of parameters required on the new stack frame

    - #### getAllVariableValues

          public Sequence[] getAllVariableValues()

      Get a all the variables in the stack frame
      Returns:
        an array holding all the variables, each referenceable by its slot number

    - #### resetAllVariableValues

          public void resetAllVariableValues(Sequence[] values)

      Overwrite all the variables in the stack frame
      Parameters:
        `values` - an array holding all the variables, each referenceable by its slot number; the caller must ensure this is the correct length (and valid in other ways)

    - #### resetParameterValues

          public void resetParameterValues(Sequence[] values)

      Overwrite all the parameters in the stack frame. (Used from compiled bytecode)
      Parameters:
        `values` - an array holding all the parameters, each referenceable by its slot number; the caller must ensure this is the correct length (and valid in other ways)

    - #### requestTailCall

          public void requestTailCall(UserFunction fn,
                             Sequence[] variables)

      Reset the local stack frame. This method is used when processing a tail-recursive function. Instead of the function being called recursively, the parameters are set to new values and the function body is evaluated repeatedly
      Parameters:
        `fn` - the user function being called using tail recursion
        `variables` - the parameter to be supplied to the user function

    - #### getTailCallFunction

          public UserFunction getTailCallFunction()

      Determine whether the body of a function is to be repeated, due to tail-recursive function calls
      Returns:
        null if no tail call has been requested, or the name of the function to be called otherwise

    - #### openStackFrame

          public void openStackFrame(SlotManager map)

      Create a new stack frame for local variables, using the supplied SlotManager to define the allocation of slots to individual variables
      Parameters:
        `map` - the SlotManager for the new stack frame

    - #### openStackFrame

          public void openStackFrame(int numberOfVariables)

      Create a new stack frame large enough to hold a given number of local variables, for which no stack frame map is available. This is used in particular when evaluating match patterns of template rules.
      Parameters:
        `numberOfVariables` - The number of local variables to be accommodated.

    - #### setCurrentMode

          public void setCurrentMode(Mode mode)

      Set the current mode.
      Parameters:
        `mode` - the new current mode

    - #### getCurrentMode

          public Mode getCurrentMode()

      Get the current mode.
      Specified by:
        `getCurrentMode` in interface `XPathContext`
      Overrides:
        `getCurrentMode` in class `XPathContextMinor`
      Returns:
        the current mode. May return null if the current mode is the default mode.

    - #### setCurrentTemplateRule

          public void setCurrentTemplateRule(Rule rule)

      Set the current template. This is used to support xsl:apply-imports. The caller is responsible for remembering the previous current template and resetting it after use.
      Parameters:
        `rule` - the current template rule, or null to indicate that there is no current template rule

    - #### getCurrentTemplateRule

          public Rule getCurrentTemplateRule()

      Get the current template. This is used to support xsl:apply-imports
      Specified by:
        `getCurrentTemplateRule` in interface `XPathContext`
      Overrides:
        `getCurrentTemplateRule` in class `XPathContextMinor`
      Returns:
        the current template

    - #### setCurrentGroupIterator

          public void setCurrentGroupIterator(GroupIterator iterator)

      Set the current grouping iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0
      Parameters:
        `iterator` - the new current GroupIterator

    - #### getCurrentGroupIterator

          public GroupIterator getCurrentGroupIterator()

      Get the current group iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0
      Specified by:
        `getCurrentGroupIterator` in interface `XPathContext`
      Overrides:
        `getCurrentGroupIterator` in class `XPathContextMinor`
      Returns:
        the current grouped collection

    - #### setCurrentRegexIterator

          public void setCurrentRegexIterator(RegexIterator currentRegexIterator)

      Set the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.
      Parameters:
        `currentRegexIterator` - the current regex iterator

    - #### getCurrentRegexIterator

          public RegexIterator getCurrentRegexIterator()

      Get the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.
      Specified by:
        `getCurrentRegexIterator` in interface `XPathContext`
      Overrides:
        `getCurrentRegexIterator` in class `XPathContextMinor`
      Returns:
        the current regular expressions iterator

    - #### useLocalParameter

          public int useLocalParameter(int parameterId,
                              int slotNumber,
                              boolean isTunnel)
                                throws XPathException

      Use local parameter. This is called when a local xsl:param element is processed. If a parameter of the relevant name was supplied, it is bound to the xsl:param element. Otherwise the method returns false, so the xsl:param default will be evaluated
      Specified by:
        `useLocalParameter` in interface `XPathContext`
      Overrides:
        `useLocalParameter` in class `XPathContextMinor`
      Parameters:
        `parameterId` -
        `slotNumber` -
        `isTunnel` - True if a tunnel parameter is required, else false @return ParameterSet.NOT_SUPPLIED, ParameterSet.SUPPLIED, or ParameterSet.SUPPLIED_AND_CHECKED
      Returns:
        ParameterSet.NOT_SUPPLIED, ParameterSet.SUPPLIED, or ParameterSet.SUPPLIED_AND_CHECKED
      Throws:
        `XPathException`

    - #### setTemporaryOutputState

          public void setTemporaryOutputState(boolean temporary)

      Set the XSLT output state to "temporary" or "final"
      Parameters:
        `temporary` - set to true to set temporary output state; false to set final output state

    - #### isTemporaryOutputState

          public boolean isTemporaryOutputState()

      Ask whether the XSLT output state is "temporary" or "final"
      Specified by:
        `isTemporaryOutputState` in interface `XPathContext`
      Overrides:
        `isTemporaryOutputState` in class `XPathContextMinor`
      Returns:
        true to set temporary output state; false to set final output state

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.